
/*    STAR1000.C   --  Setup Utility for Star NX-1000 Multifont Printers    */

/*    Kenneth A. Hubbard    2/5/90    */

#include <conio.h>
#include <stdio.h>
#include <bios.h>

#define  LPT1  0
#define  ESC  27
#define  ON   '1'
#define  OFF  '0'

extern void bleep( void );
extern void cls( void );
extern void locate( int row, int column );
extern void menu( void );
void output( char *str, int one_more );

void main( void )
{
    unsigned char msg[10], selection;
    cls();
    locate( 0, 0 );
    menu();
    locate( 24, 31 );

    while ( selection = (char) getch(), selection != 27 )
    {
        /* Check for null or extended key, if found dump keyboard buffer */

        if ( selection == 0 || selection == 0xe0 )
        {
            selection = (char) getch();
            continue;
        }

        /* Check for valid menu option, if valid echo keystroke */

        if (( selection >= 65 & selection <= 83 ) || ( selection >= 97  &  selection <= 115))
        {
            putch( selection );
        }

        switch ( selection )
        {
            case 'A':                 /*    Courier NLQ                */
                msg[0] = ESC;
                msg[1] = 'x';
                msg[2] = ON;
                msg[3] = ESC;
                msg[4] = 'k';
                msg[5] = 0;
                msg[6] = 0;
                output( msg, 1 );
                break;
            case 'a':
                msg[0] = ESC;
                msg[1] = 'x';
                msg[2] = OFF;
                msg[3] = 0;
                output( msg, 0 );
                break;

            case 'B':                 /*    Sanserif NLQ            */
                msg[0] = ESC;
                msg[1] = 'x';
                msg[2] = ON;
                msg[3] = ESC;
                msg[4] = 'k';
                msg[5] = 1;
                msg[6] = 0;
                output( msg, 0 );
                break;
            case 'b':
                msg[0] = ESC;
                msg[1] = 'x';
                msg[2] = OFF;
                msg[3] = 0;
                output( msg, 0 );
                break;

            case 'C':                 /*   Orator NLQ                 */
                msg[0] = ESC;
                msg[1] = 'x';
                msg[2] = ON;
                msg[3] = ESC;
                msg[4] = 'k';
                msg[5] = 2;
                msg[6] = 0;
                output( msg, 0 );
                break;
            case 'c':
                msg[0] = ESC;
                msg[1] = 'x';
                msg[2] = OFF;
                msg[3] = 0;
                output( msg, 0 );
                break;

            case 'D':                 /*   Emphasized Printing        */
                msg[0] = ESC;
                msg[1] = 'E';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 'd':
                msg[0] = ESC;
                msg[1] = 'F';
                msg[2] = 0;
                output( msg, 0 );
                break;

            case 'E':                 /*   Double-Strike Printing     */
                msg[0] = ESC;
                msg[1] = 'G';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 'e':
                msg[0] = ESC;
                msg[1] = 'H';
                msg[2] = 0;
                output( msg, 0 );
                break;


            case 'F':                 /*   Pica Pitch                 */
                msg[0] = ESC;
                msg[1] = 'P';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 'f':
                msg[0] = ESC;
                msg[1] = 'M';
                msg[2] = 0;
                output( msg, 0 );
                break;

            case 'G':                 /*   Elite Pitch                */
                msg[0] = ESC;
                msg[1] = 'M';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 'g':
                msg[0] = ESC;
                msg[1] = 'P';
                msg[2] = 0;
                output( msg, 0 );
                break;

            case 'H':                 /*   Condensed Printing         */
                msg[0] = 15;
                msg[1] = 0;
                output( msg, 0 );
                break;
            case 'h':
                msg[0] = 18;
                msg[1] = 0;
                output( msg, 0 );
                break;

            case 'I':                 /*   Expanded Printing          */
                msg[0] = ESC;
                msg[1] = 'W';
                msg[2] = ON;
                msg[3] = 0;
                output( msg, 0 );
                break;
            case 'i':
                msg[0] = ESC;
                msg[1] = 'W';
                msg[2] = OFF;
                msg[3] = 0;
                output( msg, 0 );
                break;

            case 'J':                 /*   Proportional Spacing       */
                msg[0] = ESC;
                msg[1] = 'p';
                msg[2] = ON;
                msg[3] = 0;
                output( msg, 0 );
                break;
            case 'j':
                msg[0] = ESC;
                msg[1] = 'p';
                msg[2] = OFF;
                msg[3] = 0;
                output( msg, 0 );
                break;

            case 'K':                 /*   Italic Characters          */
                msg[0] = ESC;
                msg[1] = '4';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 'k':
                msg[0] = ESC;
                msg[1] = '5';
                msg[2] = 0;
                output( msg, 0 );
                break;

            case 'L':                 /*   Underlined Characters      */
                msg[0] = ESC;
                msg[1] = '-';
                msg[2] = ON;
                msg[3] = 0;
                output( msg, 0 );
                break;
            case 'l':
                msg[0] = ESC;
                msg[1] = '-';
                msg[2] = OFF;
                msg[3] = 0;
                output( msg, 0 );
                break;

            case 'M':                 /*   Double-Size Characters     */
                msg[0] = ESC;
                msg[1] = 'h';
                msg[2] = 1;
                msg[3] = 0;
                output( msg, 0 );
                break;
            case 'm':
                msg[0] = ESC;
                msg[1] = 'h';
                msg[2] = 0;
                msg[3] = 0;
                output( msg, 1 );
                break;

            case 'N':                 /*   Line Feed                 */
                msg[0] = 10;
                msg[1] = 0;
                output( msg, 0 );
                break;
            case 'n':
                msg[0] = 10;
                msg[1] = 0;
                output( msg, 0 );
                break;

            case 'O':                 /*   Form Feed                 */
                msg[0] = 12;
                msg[1] = 0;
                output( msg, 0 );
                break;
            case 'o':
                msg[0] = 12;
                msg[1] = 0;
                output( msg, 0 );
                break;

            case 'P':                 /*   1/6th-inch Line Spacing    */
                msg[0] = ESC;
                msg[1] = '2';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 'p':
                msg[0] = ESC;
                msg[1] = '0';
                msg[2] = 0;
                output( msg, 0 );
                break;

            case 'Q':                 /*   1/8th-inch Line Spacing    */
                msg[0] = ESC;
                msg[1] = '0';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 'q':
                msg[0] = ESC;
                msg[1] = '2';
                msg[2] = 0;
                output( msg, 0 );
                break;

            case 'R':                 /*   Left Margin to 10          */
                msg[0] = ESC;
                msg[1] = 'l';
                msg[2] = 10;
                msg[3] = 0;
                output( msg, 0 );
                break;
            case 'r':
                msg[0] = ESC;
                msg[1] = 'l';
                msg[2] = 0;
                msg[3] = 0;
                output( msg, 1 );
                break;

            case 'S':                 /*   Reset Printer              */
                msg[0] = ESC;
                msg[1] = '@';
                msg[2] = 0;
                output( msg, 0 );
                break;
            case 's':
                msg[0] = ESC;
                msg[1] = '@';
                msg[2] = 0;
                output( msg, 0 );
                break;
        }
    }
    cls();
    locate( 0, 0 );
}

void output( char str[], int one_more )
{
    int i = -1, a, stat;

    while ( str[++i] != 0 )
    {
        a = str[i];
        stat = _bios_printer( _PRINTER_WRITE, LPT1, a );

        /* Check for error status by masking the status byte returned
           by _bios_printer. Conditions checked are TIMEOUT (1), I/O
           ERROR (8), and PAPER OUT (32).                            */

        if ( stat & 1 || stat & 8 || stat & 32 )
        {
            bleep();
            putch( 8 );
            putch( ' ' );
            putch( 8 );
            putch( 8 );
            break;
        }
    }

    /* One_more is set when the last character of the printer setup code
       is 0. Because a null terminates the above loop, a null is sent to
       the printer to complete the setup code.                           */

    if ( one_more )
    {
        _bios_printer( _PRINTER_WRITE, LPT1, 0 );
    }

    putch( ' ' );
}
